﻿Option Strict On

Imports Microsoft.Kinect
Imports Coding4Fun.Kinect.Wpf

Imports Microsoft.Speech.Recognition '音声認識をするためのクラスが含まれる。
Imports Microsoft.Speech.AudioFormat '音声認識のオーディオ形式を表わすクラスが含まれる。

Imports System.IO

Class MainWindow
    Dim myKinect As KinectSensor
    Dim xmldoc As XElement
  

    Dim index As Integer
    Dim engine As SpeechRecognitionEngine
    Dim words As String
    Private Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        xmldoc = XElement.Load("URL.xml")
        Dim sentence As Choices = New Choices

        For Each result In From c In xmldoc.Descendants("name") Select c
            If result.Value <> String.Empty Then
                sentence.Add(result.Attribute("tolower").Value)
                Dim myTextBlock As New TextBlock
                myTextBlock.FontSize = 20
                myTextBlock.FontWeight = FontWeights.Bold
                myTextBlock.Text = result.Attribute("tolower").Value
                stackPanel1.Children.Add(myTextBlock)
            End If

        Next

        With sentence
            .Add("Back")
            .Add("Next")
            .Add("End")
        End With

        If KinectSensor.KinectSensors.Count > 0 Then
            myKinect = KinectSensor.KinectSensors(0)
            myKinect.Start()
        End If


        Dim builder As GrammarBuilder = New GrammarBuilder()
        builder.Append(sentence)
        Dim myGrammer As Grammar = New Grammar(builder)
        engine = New SpeechRecognitionEngine
        engine.LoadGrammar(myGrammer)


        AddHandler engine.SpeechRecognized, Sub(speechSender As Object, speechArgs As SpeechRecognizedEventArgs)
                                                Dim confidence As Single = speechArgs.Result.Confidence
                                                If confidence > 0.5 Then

                                                    words = speechArgs.Result.Text

                                                    Select Case words
                                                        Case words
                                                            Dim query = From c In xmldoc.Descendants("name") Where c.Attribute("tolower").Value.Equals(words) Select c
                                                            For Each result In query
                                                                webBrowser1.Navigate(New Uri(result.Value, UriKind.Absolute))
                                                            Next

                                                            If words = "End" Then
                                                                If myKinect.IsRunning = True Then
                                                                    myKinect.Stop()

                                                                    myKinect.AudioSource.Stop()
                                                                End If
                                                                Environment.Exit(0)
                                                            End If


                                                            If words = "Back" Then
                                                                If webBrowser1.CanGoBack = True Then
                                                                    webBrowser1.GoBack()
                                                                End If
                                                            End If

                                                            If words = "Next" Then
                                                                If webBrowser1.CanGoForward = True Then
                                                                    webBrowser1.GoForward()
                                                                End If
                                                            End If
                                                        Case Else
                                                            Exit Select
                                                    End Select
                                                End If
                                            End Sub

        Dim audio As KinectAudioSource = myKinect.AudioSource

        Using s As Stream = audio.Start()
            engine.SetInputToDefaultAudioDevice()
            engine.RecognizeAsync(RecognizeMode.Multiple)
        End Using

        Try
            myKinect.ColorStream.Enable()
            AddHandler myKinect.ColorFrameReady, AddressOf myKinect_ColorFrameReady

        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Close()
        End Try
    End Sub

    Private Sub myKinect_ColorFrameReady(sender As Object, e As ColorImageFrameReadyEventArgs)
        Using myColorImage As ColorImageFrame = e.OpenColorImageFrame
            sourceImage.Source = myColorImage.ToBitmapSource
        End Using
    End Sub


    Private Sub MainWindow_Closing(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles Me.Closing
        If myKinect Is Nothing = False Then
            If myKinect.IsRunning = True Then
                RemoveHandler myKinect.ColorFrameReady, AddressOf myKinect_ColorFrameReady
                myKinect.Stop()
                engine.RecognizeAsyncStop()
                myKinect.Dispose()
            End If
        End If
    End Sub

End Class
